<template>
  <view class="c-card">
    <u-form
      labelPosition="left"
      :model="model1"
      :rules="model1.formData.id ? rules2 : rules1"
      ref="form"
      :labelWidth="100"
      :labelStyle="{ padding: '0rpx 10rpx' }"
      :errorType="'border-bottom'"
    >
      <u-form-item
        :prop="`formData.${item.key}`"
        :label="item.name"
        :required="item.required"
        v-for="(item, index) in model1.formData.id ? formAttrList2 : formAttrList1"
        :key="index"
        @click="item.fn"
      >
        <u-textarea
          v-if="item.type === 'textarea'"
          v-model="(model1.formData as any)[item.key]"
          :placeholder="`请输入${item.name}`"
        ></u-textarea>
        <u-input
          v-if="item.type === 'select' || item.type === 'input'"
          :password="item.key === 'password'"
          v-model="(model1.formData as any)[item.key]"
          :placeholder="`请${item.type === 'select' ? '选择' : '输入'}${
            item.name
          }`"
          clearable
          :customStyle="{}"
          border="none"
          :maxlength="item.key === 'password' ? 8 : -1"
          @change="(e:any) => {handleInput(e, item)}"
          :disabled="item.type === 'select'"
          :disabledColor="
            ['性别', '用户角色'].indexOf(item.name) > -1 ? '#ffffff' : '#f5f7fa'
          "
          @clear="handleClear(item)"
        >
          <template #suffix>
            <text>
              {{ item.unit }}
            </text>
          </template>
        </u-input>
        <template #right v-if="item.type === 'select'">
          <u-icon name="arrow-right"></u-icon>
        </template>
      </u-form-item>
    </u-form>
    <block v-for="(item, index) in model1.formData.id ? formAttrList2 : formAttrList1" :key="index">
      <u-action-sheet
        v-if="item.type === 'select'"
        :actions="contrlModalParams[item.childKey].list"
        :title="contrlModalParams[item.childKey].title"
        :show="contrlModalParams[item.childKey].isShow"
        @select="(v: any) => handleSelect(item.childKey, v)"
        @close="contrlModalParams[item.childKey].isShow = false"
        :closeOnClickAction="true"
      ></u-action-sheet>
    </block>
  </view>
  <view class="btn-box">
    <u-button type="primary" text="保存" @click="save()"></u-button>
  </view>
</template>
<script setup lang="ts">
import { ProfileApi, StockCardApi } from "@/services";
import { formatDate } from "@/utils";
import { DeviceType, ImagesType, OrderType, StockCardType } from "@/utils/enum";
import valid from "@/utils/validate";
import { onLoad } from "@dcloudio/uni-app";
import _ from "underscore";
const handleClear = (item: any) => {
  (model1.formData as any)[item.key] = "";
};
const handleInput = (e: any, item: any) => {
  if (item.key === "phone") {
    const temp = e?.replace(valid.valid_number, "");
    setTimeout(() => {
      model1.formData[item.key] = temp;
    }, 10);
  }
  if (item.key === "password") {
    const temp = e?.replace(valid.valid_no_cn, "");
    setTimeout(() => {
      (model1.formData as any)[item.key] = temp;
    }, 10);
  }
};
const model1 = reactive<any>({
  formData: {},
});
const rules1 = ref({
  "formData.roleName": {
    type: "string",
    required: true,
    message: "请选择用户角色",
    trigger: ["blur", "change"],
  },
  "formData.userName": {
    type: "string",
    required: true,
    message: "请输入账号",
    trigger: ["blur", "change"],
  },
  "formData.password": {
    type: "string",
    required: true,
    message: "请输入密码",
    trigger: ["blur", "change"],
  },
});
const rules2 = ref({
  "formData.roleName": {
    type: "string",
    required: true,
    message: "请选择用户角色",
    trigger: ["blur", "change"],
  },
  "formData.userName": {
    type: "string",
    required: true,
    message: "请输入账号",
    trigger: ["blur", "change"],
  },
});
const contrlModalParams = reactive<any>({
  role: {
    isShow: false,
    title: "标题",
    list: [],
  },
  gender: {
    isShow: false,
    title: "标题",
    list: [
      {
        id: 1,
        name: "男",
      },
      {
        id: 2,
        name: "女",
      },
    ],
  },
});

const formAttrList1 = reactive<any>([
  {
    name: "姓名",
    key: "name",
    type: "input",
  },
  {
    name: "性别",
    key: "genderName",
    type: "select",
    childKey: "gender",
    fn: () => {
      contrlModalParams.gender.isShow = true;
      contrlModalParams.gender.title = "选择性别";
    },
  },
  {
    name: "用户角色",
    key: "roleName",
    type: "select",
    childKey: "role",
    required: true,
    fn: () => {
      contrlModalParams.role.isShow = true;
      contrlModalParams.role.title = "选择角色";
    },
  },
  {
    name: "账号",
    key: "userName",
    type: "input",
    required: true,
  },
  {
    name: "密码",
    key: "password",
    type: "input",
    required: true,
  },
  {
    name: "联系手机",
    key: "phone",
    type: "input",
  },
]);

const formAttrList2 = reactive<any>([
  {
    name: "姓名",
    key: "name",
    type: "input",
  },
  {
    name: "性别",
    key: "genderName",
    type: "select",
    childKey: "gender",
    fn: () => {
      contrlModalParams.gender.isShow = true;
      contrlModalParams.gender.title = "选择性别";
    },
  },
  {
    name: "用户角色",
    key: "roleName",
    type: "select",
    childKey: "role",
    required: true,
    fn: () => {
      contrlModalParams.role.isShow = true;
      contrlModalParams.role.title = "选择角色";
    },
  },
  {
    name: "账号",
    key: "userName",
    type: "input",
    required: true,
  },
  {
    name: "联系手机",
    key: "phone",
    type: "input",
  },
]);

const handleSelect = (key: string, v: any) => {
  contrlModalParams[key].isShow = false;
  if (key === "role") {
    model1.formData.roleName = v.name;
    model1.formData.roleIds = [v.id];
  }
  if (key === "gender") {
    model1.formData.genderName = v.name;
    model1.formData.gender = v.id;
  }
};

const form = ref();
const check = () => {
  return new Promise((resolve) => {
    form.value
      .validate()
      .then((res: boolean) => {
        resolve(res);
      })
      .catch((errors: any) => {
        resolve(false);
        uni.showToast({
          icon: "none",
          title: errors[0].message || "校验失败",
        });
      });
  });
};

const save = () => {
  if (model1.formData.phone) {
    if (!valid.mobile.pattern.test(model1.formData.phone)) {
      uni.showToast({ icon: "none", title: "请输入正确的手机号" });
      return;
    }
  }
  if (!model1.formData.id) {
    if (model1.formData.password) {
      if (!valid.valid_password.pattern.test(model1.formData.password)) {
        uni.showToast({
          icon: "none",
          title: valid.valid_password.message,
        });
        return;
      }
    }
  }

  check().then((res) => {
    if (res) {
      startSave();
    }
  });
};

const startSave = () => {
  if (model1.formData.id) {
    ProfileApi.updateUserById({
      name:  model1.formData.name,
      id: model1.formData.id,
      roleIds: model1.formData.roleIds,
      userName: model1.formData.userName,
      phone: model1.formData.phone,
      gender: model1.formData.gender,
    }).then((res) => {
      if (res.code === 200) {
        uni.navigateBack();
      }
    });
  } else {
    ProfileApi.addUser({ userType: 1, ...model1.formData }).then((res) => {
      if (res.code === 200) {
        uni.navigateBack();
      }
    });
  }
};

const getRoleList = () => {
  ProfileApi.getRoleList({}).then((res) => {
    if (res.code === 200) {
      contrlModalParams.role.list = (res.data as any).map((item: any) => {
        return { ...item, name: item.roleName };
      });
      console.log(contrlModalParams.role.list);
    }
  });
};

onMounted(() => {
  getRoleList();
});

onLoad((option) => {
  // 接收传递的标题参数;
  const title = (option as any).title;
  const obj = JSON.parse((option as any).item);
  model1.formData = { ...obj, genderName: ["未知", "男", "女"][obj.gender] };
  if (obj.roleVos.length > 0) {
    model1.formData.roleIds = [obj.roleVos[0].id];
    model1.formData.roleName = obj.roleVos[0].roleName;
  }
  // 设置页面标题;
  if (title) {
    uni.setNavigationBarTitle({
      title: title,
    });
  }
});
</script>
<style lang="scss" scoped>
.c-card {
  background: #ffffff;
  // box-shadow: 0rpx 0rpx 10rpx 0rpx rgba(5, 68, 37, 0.12);
  border-radius: 13rpx;
  margin: 30rpx 25rpx;
  padding: 0rpx 20rpx;
  ::v-deep .u-form-item {
    height: auto;
  }
  ::v-deep .u-form-item + .u-form-item {
    border-top: 1rpx solid rgba(233, 233, 233, 0.76);
  }
}
.btn-box {
  margin-top: 60rpx;
  display: flex;
  background: #ffffff;
  box-shadow: 0rpx 0rpx 10rpx 0rpx rgba(0, 56, 93, 0.12);
  border-radius: 13rpx 13rpx 0rpx 0rpx;
  padding: 25rpx 50rpx;
  position: sticky;
  bottom: 0rpx;
  z-index: 999;
  ::v-deep button {
    border-radius: 43rpx;
  }
}
</style>
